	.file	"strncat.S"

	.section .text
	.global  _strncat
	.type	 _strncat,@function
_strncat:
	;; R1 : Destination
	;; R2 : Source
	;; R3 : Max number of bytes to copy
#ifdef __RX_ALLOW_STRING_INSNS__
	mov 	r1, r4		; Save a copy of the dest pointer.
	pushm	r2-r3		; Save a copy of the parameters.
	mov	#0, r2		; Search for the NUL byte.
	not 	r2, r3		; No limit on the number of bytes examined.
	suntil.b		; Find the end of the destination string.
	sub	#1, r1		; suntil.b leaves r1 pointing to the byte beyond the NUL.
	popm	r2-r3		; Restore a copy of the parameters.
	smovu			; Copy source to destination.
	mov.b	[-r1], r2	; Need to read back last written character,
	cmp	#0, r2		; since we can't compare r3 directly, 
	beq	1f              ; because of cornercase r3=0, [r2]=NUL.
	mov.b	#0, 1[r1]	; Add NUL.
1:	mov	r4, r1		; Return the original dest pointer.	
	rts
#else
	cmp	#0, r3		; If max is zero we have nothing to do.
	beq	3f
	mov 	r1, r4		; Leave the destination pointer intact for the return value.
1:	mov.b	[r4+], r5	; Find the NUL byte at the end of the destination.
	cmp	#0, r5
	bne	1b
	sub	#1, r4
2:	mov.b	[r2+], r5	; Copy bytes from the source into the destination ...
	mov.b	r5, [r4+]
	cmp	#0, r5		; ... until we reach a NUL byte ...
	beq 	3f
	sub	#1, r3
	bne	2b		; ... or we have copied N bytes.
	mov.b	#0, [r4]	; Add NUL.
3:	rts
#endif
	.size _strncat, . - _strncat
	
