	.file	"e_sqrt.S"

	.section .text
#if __RX_64BIT_DOUBLES__
	.global  ___ieee754_sqrt
	.type	 ___ieee754_sqrt,@function

___ieee754_sqrt:
        pushm r6-r7

        cmp   #0x7ff00000,r2
        bgeu  .ret_nan
        shlr  #20,r2,r15
        ble   .subnormal
        cmp   #0x7ff,r15
        beq   .ret
.continue:

        shlr  #21,r1,r4
        shll  #11,r1,r6
        shll  #11,r2,r7
        add   r4,r7
        bset  #31,r7

        shlr  #16,r7,r4
        btst  #0,r15
        beq   .odd
.even:
        mul   #0x5414,r4
        shlr  #15,r4
        mov.l #0x15413,r3
        sub   r4,r3,r4
        shlr  #1,r7
        rorc  r6
        bra   .step1
.odd:
        mul   #0x2BEC,r4
        shlr  #15,r4
        mov.l #0xD7D8,r3
        sub   r4,r3,r4
.step1:
        push  r15

        mul   r4,r4,r5
        shlr  #16,r5
        shlr  #16,r7,r1
        mul   r5,r1
        add   #0x40000000,r1,r1
        neg   r1
        shlr  #16,r1
        mul   r1,r4
        shlr  #15,r4

        mul   r4,r4,r5
        shlr  #16,r5
        shlr  #16,r7,r3
        mul   r5,r3
        add   #0x40000000,r3,r3
        neg   r3
        shlr  #16,r3
        mul   r4,r3
        shlr  #15,r3
.step2:

        mul   r3,r3,r4
        emulu r7,r4
        shlr  #1,r5,r1
        add   r5,r1
        shlr  #1,r1
        add   #0x60000000,r1,r1
        neg   r1
        shll  #1,r1
        shll  #1,r4
        rolc  r5
        mov.l r5,r14
        emulu r1,r14
        emulu r4,r1
        add   r2,r14
        adc   #0,r15
        mov.l #0xF0000000,r4
        neg   r14
        sbb   r15,r4
        shll  #16,r3
        emulu r3,r14
        emulu r3,r4
        add   r15,r4
        adc   #0,r5
        shll  #1,r4
        rolc  r5
.step3:

        mov.l r5,r3
        emulu r5,r3
        mov.l r4,r14
        emulu r7,r14
        mov.l r4,r1
        emulu r7,r3
        add   r4,r14
        adc   #0,r15
        emulu r6,r1
        add   r2,r14
        adc   #0,r15
        mov.l #0xC0000000,r3
        neg   r14
        sbb   r15,r3
        emulu r5,r14
        emulu r5,r3
        add   r15,r3
        adc   #0,r4
.step4:

        mov.l r7,r1
        emulu r4,r1
        emulu r6,r4
        add   r5,r1
        adc   #0,r2
        emulu r7,r3
        mov.l [r0],r3
        add   r4,r1
        adc   #0,r2
.step5:

        add   #0x3ff,r3,r3
        shlr  #1,r3
        add   #0x100,r1,r1
        adc   #0,r2
        adc   #0,r3
        shll  #23,r2,r4
        shlr  #9,r2
        shlr  #9,r1
        add   r4,r1
        bclr  #20,r2
        shll  #20,r3
        add   r3,r2
        rtsd  #12,r6-r7

.ret_nan:
        beq   .ret
        shll  #1,r2,r3
        or    r1,r3
        beq   .ret
        mov.l #-1,r2
.ret:   rtsd  #8,r6-r7

.subnormal:
        or    r2,r1,r3
        beq   .ret
        bra   .subnorm_a64
.subnorm_a64_loop:
        shll  #1,r1
        rolc  r2
        sub   #1,r15
.subnorm_a64:
        btst  #20,r2
        beq   .subnorm_a64_loop
        add   #1,r15
        bra   .continue

	.size ___ieee754_sqrt, . - ___ieee754_sqrt
#endif
