	.file	"e_sqrt.S"

	.section .text
#if __RX_32BIT_DOUBLES__
	.global  ___ieee754_sqrt
	.type	 ___ieee754_sqrt,@function
#endif
	.global  ___ieee754_sqrtf
	.type	 ___ieee754_sqrtf,@function
#if __RX_32BIT_DOUBLES__
___ieee754_sqrt:
#endif
___ieee754_sqrtf:

        cmp     #0x7f800000,r1
        bgeu    .ret_nan

        shlr    #23,r1,r15
        beq     .subn
        and     #0x007fffff,r1
        bset    #23,r1

.cont:
        add     #-0x7f,r15,r15
        shar    #1,r15
        bc      .odd

.even:
        mov.l   #0x49374BC6,r14
        divu    r1,r14
        add     #0x6e,r14,r14
        bra     .start

.odd:
        shll    #1,r1
        mov.l   #0x6D916872,r14
        divu    r1,r14
        add     #0x4a,r14,r14

.start:
        shlr    #2,r1,r2
        mul     r14,r2
        shlr    #8,r2
        mul     r14,r2
        shlr    #1,r2,r3
        add     r2,r3
        add     #0x60000000,r3
        neg     r3
        emulu   r3,r2
        mov.l   #0x1e000000,r2
        sub     r3,r2
        shlr    #5,r2
        mul     r14,r2

        mov.l   r2,r14
        emulu   r2,r2
        shll    #1,r3
        shll    #7,r1,r2
        emulu   r3,r2
        shll    #1,r2
        rolc    r3
        neg     r2
        mov.l   #0xC0000000,r2
        sbb     r3,r2
        emulu   r14,r2

        shll    #2,r1
        emulu   r3,r1

        add     #0x7f,r15
        shll    #23,r15
        bclr    #23,r2
        add     #0x7fffffff,r1
        adc     r15,r2
        mov.l   r2,r1

        rts

.ret_nan:
        beq     .return
        shll    #1,r1,r2
        beq     .return
        mov.l   #-1,r1
.return:
        rts

.subn:  cmp     #0,r1
        beq     .return
        bra     .subnorm_a32
.subnorm_a32_loop:
        shll    #1,r1
        sub     #1,r15
.subnorm_a32:
        btst    #23,r1
        beq     .subnorm_a32_loop
        add     #1,r15
        bra     .cont

#if __RX_32BIT_DOUBLES__
	.size ___ieee754_sqrt, . - ___ieee754_sqrt
#endif
	.size ___ieee754_sqrtf, . - ___ieee754_sqrtf
